(function() {
  var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  }, __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
  PuppetEnterpriseConsole.Resource = (function() {
    __extends(Resource, Batman.Model);
    function Resource() {
      Resource.__super__.constructor.apply(this, arguments);
    }
    Resource.global(true);
    Resource.encode('title', 'properties', 'variations', 'nodeCount');
    Resource.primaryKey = 'title';
    Resource.storageKey = 'resources';
    return Resource;
  })();
  PuppetEnterpriseConsole.ResourceType = (function() {
    __extends(ResourceType, Batman.Model);
    function ResourceType() {
      ResourceType.__super__.constructor.apply(this, arguments);
    }
    ResourceType.global(true);
    ResourceType.persist(Batman.RestStorage);
    ResourceType.url = "/live-management/lm/resource_types";
    ResourceType.primaryKey = 'name';
    ResourceType.encode('name');
    ResourceType.accessor('type', function() {
      return this.get('name');
    });
    return ResourceType;
  })();
  PuppetEnterpriseConsole.prevent('run');
  ResourceType.load(function(_, types) {
    var type, _i, _len;
    for (_i = 0, _len = types.length; _i < _len; _i++) {
      type = types[_i];
      Resource[type.get('name')] = (function() {
        var loadedSet;
        __extends(_Class, Resource);
        _Class.__name__ = type.get('name');
        _Class.set('loadingState', new StateMachine());
        function _Class() {
          _Class.__super__.constructor.apply(this, arguments);
          this.set('loadingState', new StateMachine());
        }
        _Class.persist(Batman.RestStorage.Filtered.ByNodeSet).after('readAll', __bind(function(args) {
          this.set('rawData', args[2]);
          return args;
        }, _Class));
        PuppetEnterpriseConsole.on('ready', __bind(function() {
          return Node.observe('nodeSetID', __bind(function() {
            return this.invalidate();
          }, this));
        }, _Class));
        loadedSet = new Batman.Set();
        loadedSet.accessor('timeago', function() {
          Timer.get('everyMinute');
          if (this.get('timestamp') != null) {
            return jQuery.timeago(this.get('timestamp'));
          }
        });
        _Class.set('loadedForSelection', loadedSet);
        _Class.classAccessor('forSelection', {
          get: function() {
            var resources;
            resources = this.get('loadedForSelection');
            if (!resources.get('state')) {
              resources.set('state', 'loading');
              resources.unset('total');
              resources.unset('variations');
              resources.unset('unique');
              resources.clear();
              this.load(__bind(function(err, nodes) {
                var now;
                resources.add.apply(resources, nodes);
                resources.set('state', 'loaded');
                now = new Date();
                resources.set('humanTime', "" + (now.toLocaleDateString()) + " at " + (now.toLocaleTimeString()));
                resources.set('timestamp', now);
                return resources.set('similarity', Batman.Filters.asPercentOf(resources.variations - resources.unique, resources.total - resources.unique, true));
              }, this));
            }
            return resources;
          }
        });
        _Class.classAccessor('rawData', {
          set: function(k, v) {
            this.get('forSelection').set('total', v.total);
            this.get('forSelection').set('variations', v.variations);
            return this.get('forSelection').set('unique', v.resources.length);
          }
        });
        _Class.invalidate = function() {
          this.get('loaded').clear();
          this.get('loadedForSelection').clear();
          this.get('loadedForSelection').unset('state');
          this.get('loadedForSelection').unset('total');
          this.get('loadedForSelection').unset('humanTime');
          this.get('loadedForSelection').unset('timestamp');
          this.get('loadedForSelection').unset('similarity');
          this.get('loadedForSelection').unset('name');
          return this;
        };
        _Class.url = "/live-management/lm/resources/" + (type.get('name'));
        _Class.prototype.url = function() {
          return "" + this.constructor.url + "/" + (this.get('title'));
        };
        _Class.accessor('isoTimestamp', function() {
          var _ref;
          Timer.get('everyMinute');
          return (_ref = this.get('timestamp')) != null ? _ref.toISOString() : void 0;
        });
        return _Class;
      }).call(this);
      PuppetEnterpriseConsole.route("" + (type.get('name')) + "/:id", 'resources#details', {
        resource: Batman.helpers.pluralize(type.get('name')),
        action: 'details'
      });
      PuppetEnterpriseConsole.route(PuppetEnterpriseConsole.dispatcher);
    }
    PuppetEnterpriseConsole.allow('run');
    if (PuppetEnterpriseConsole.wantsToRun) {
      return PuppetEnterpriseConsole.run();
    }
  });
}).call(this);
